#pragma once

#include "common.h"


#if 0
#define IGMP_VER2					(0x01)
#define IGMP_VER3					(0x02)


#define IGMPV2_TYPE_JOIN			(0x16)
#define IGMPV2_TYPE_LEAVE			(0x17)
#define IGMPV3_TYPE_REPORT			(0x22)

#define IGMPV3_GRPREC_OFFSET		(8)
#define IGMPV3_REC_AUXLEN_OFFSET	(1)
#define IGMPV3_REC_NUMSRC_OFFSET	(2)
#define IGMPV3_REC_GROUP_OFFSET		(4)
#define IGMPV3_REC_SOURCE_OFFSET	(8)

#define IGMPV3_REC_HEADER_SIZE		(4)

/* IGMP V3 record type */
#define IGMPV3_MODE_IS_INCLUDE				(1)
#define IGMPV3_MODE_IS_EXCLUDE				(2)
#define IGMPV3_CHANGE_TO_INCLUDE_MODE		(3)
#define IGMPV3_CHANGE_TO_EXCLUDE_MODE		(4)
#define IGMPV3_ALLOW_NEW_SOURCES			(5)
#define IGMPV3_BLOCK_OLD_SOURCES			(6)


/* group info structure */
typedef struct tGROUPINFO
{
	unsigned long	ulGroup;
	unsigned long	ulSource;
}GROUPINFO, * PGROUPINFO;

typedef struct tIGMP_QUERY_PKT
{
	unsigned char* puchBuffer;
	int            nLen;
}IGMP_QUERY_PKT;

/* IGMPv2 */
typedef struct tIGMPV2
{
	unsigned char	uchType;
	unsigned char	uchRespTime;
	unsigned short	usChecksum;
	unsigned long	ulGroup;

}IGMPV2,* PIGMPV2;
#endif


class CCurrentGroupInfo
{

public:
	CCurrentGroupInfo(void);
	~CCurrentGroupInfo(void);

	int  GetSize();
	
	
	void SetIFAddress( string ); // get current default interface address IPv4 string

	// add or delete (S,G)
	BOOL AddGroup( unsigned long ulGroup, unsigned long ulSource );
	BOOL DeleteGroup(unsigned long ulGroup, unsigned long ulSource);
	
	int  GetSourceSize( int nGrpIndex );
	ULONG  GetSrc( int nGrpIndex, ULONG* pOutSrc );

	static CRITICAL_SECTION g_csGroupInfo;


	//int  GetNumberOfGroup();
	//void GetIGMPV3Query( unsigned char** pOutBufferPtr , unsigned int* unLen );

	//void UpdateGroupInfo( unsigned char* puchIGMPPkt, int nLen );

	/* for packet creation service */
	// return number of packet to return
	//int GetIGMPPacket( void );
	//BOOL NextPacket( unsigned char** ppIGMPPkt, int* pLen );



protected:

	void DumpTable();
	//void AddGroup( unsigned long ulGroup, unsigned long ulSource );
	//void DeleteGroup(unsigned long ulGroup, unsigned long ulSource);
	void DeleteAllGroup(unsigned long ulGroup);
	//void VerifyIGMPVersion( unsigned int unIGMPVer );


	//unsigned short GetChecksum(unsigned short *pusIPBuffer, int nLen);



private:

	list<vector<unsigned long>> m_listGroupEntryTbl; // table container
		int						m_nSize; // table size
	
	/* for packet creation service */
	//vector<IGMP_QUERY_PKT>	m_vecIGMPQuery;
	unsigned int			m_unInitialIGMPVer;
	unsigned long			m_ulIFAddr;
	int						m_nPktVecIndex;
};
