#pragma once

#include "common.h"

/* IGMPv3 - not includeing source address */

#define	MAX_SOURCES		10
#define	MAX_GROUPS		10
#define ALL_ROUTERS				"224.0.0.2"
#define ALL_IGMPV3_ROUTERS		"224.0.0.22"
#define SIZE_IPHEADER	20

typedef struct tGROUP_RECORD
{
	unsigned char	uchRecType;
	unsigned char	uchAuxLen;
	unsigned short	usNumSrc;
	unsigned long	ulGrpAddr;
	unsigned long	aulSrcAddr[1];
	//unsigned char	auAuxData[1]; // no aux for this project
}GROUP_RECORD, *PGROUP_RECORD;

typedef struct tIGMPV3_MEMBERSHIP
{
	unsigned char	uchType;
	unsigned char	ucReserved;
	unsigned short	usChecksum;
	unsigned short	usReserved;
	unsigned short	usNumGroup;
	GROUP_RECORD	stGrpRecord[1];
}IGMPV3_MEMBERSHIP,* PIGMPV3_MEMBERSHIP;

typedef struct tIP_HEADER
{
	unsigned char	uchVerLen;
	unsigned char	uchTypeSvc;
	unsigned short	usTotLen;
	unsigned short	usID;
	unsigned short  usFlagFrag;
	unsigned char	uchTTL;
	unsigned char	uchProtocol;
	unsigned short  usChecksum;
	unsigned long	ulSrcIP;
	unsigned long	ulDestIP;

}IP_HEADER, *PIP_HEADER;


class CIGMPPktGen
{
public:
	CIGMPPktGen(void);
	~CIGMPPktGen(void);

	void GetIGMPMembershipPkt( BOOL bMode, 
							ULONG* pulSrc,
							int nNumSrc,
							ULONG ulGroup,
							const char* szSrcIP,
							unsigned char** ppOutBuffer,
							int* pnOutLen );

protected:
	unsigned short GetChecksum(unsigned short *pusIPBuffer, int nLen);

};
