/*
* AMT Gateway Win32 version
*
* THE UNIVERSITY OF TEXAS AT DALLAS, ANDES Lab.
*
* Author: Juhyun Oh (Justin), justinoh@student.utdallas.edu
*
*/

#pragma once

#include "common.h"
#include "PktSender.h"
#include "CurrentGroupInfo.h"

#define IPTOSBUFFERS    12
#define IGMP_INTERVAL	(3) // 3 sec

#define PCAP_IPHEADER_OFFSET	(14)
#define PCAP_IPSRC_OFFSET		(26)
#define PCAP_IPDEST_OFFSET		(30)

typedef struct tLATESTIGMP
{
	unsigned char*	pIGMPPkt;
	unsigned int	unTimestamp;
}LATESTIGMP;

class CPktMonitor
{
public:
	CPktMonitor(void);
	CPktMonitor(HANDLE);
	~CPktMonitor(void);


	static void PktMonProc( void* );
	void InitializePktMonProc( void );
	BOOL InitializePcap( string& );
	void SetPktSenderObj( CPktSender* );
	void SetGroupInfoObj( CCurrentGroupInfo* );
	
	string& GetActiveIFName();
	int GetRequest( REQUEST& );
	char* iptos(unsigned long );

	static CRITICAL_SECTION g_csTempReqQ;

protected:
	void SetInterfaceIP( string& );
	
private:
	string    m_strUsrSetInterfaceIP;
	string    m_strActiveIF;

	
	pcap_t*   m_pPcapDevHndl;
	HANDLE    m_hPktMonThread;
	HANDLE    m_hReqRcvEvent;

	const unsigned char*    m_pucPktBuffer;
	unsigned int            m_nPktLength;

	list<REQUEST>    m_listTempReqQ;
	CPktSender*      m_pObjPkrtSender;
	//char             m_acLocalMAC[6];
	BOOL             m_bRefreshMAC;
	CCurrentGroupInfo*	m_pObjGroupInfo;

	list<LATESTIGMP>	m_listIGMPHistory;

};
