/*
* AMT Gateway Win32 version
*
* THE UNIVERSITY OF TEXAS AT DALLAS, ANDES Lab.
*
* Author: Juhyun Oh (Justin), justinoh@student.utdallas.edu
*
*/

#pragma once
#include "common.h"

#define PCAP_Q_SEND 0
#define Q_SIZE      40960
#define ENQUEUE     4

typedef struct tMyPkt
{
	unsigned char* pPktData;
	unsigned int ulSize;
}MyPkt;



class CPktSender
{
public:
	CPktSender(void);
	CPktSender(string&, unsigned char*);
	~CPktSender(void);
	
	BOOL SendPkt( unsigned char*, unsigned int );
	void SetMACLocalMACAddr( unsigned char* );

protected:
	BOOL InitializePktSender( void );
	BOOL InitializePcap( string& );
	//u16 udp_sum_calc(u16, u16*,u16*, BOOL, unsigned char*);
	WORD GetUDPChecksum( unsigned char* );

private:

	pcap_t*         m_pDevPcapHndl;  // pcap device handle pointer
	string          m_strActiveIF;   // active interface
	char            m_achLastError[PCAP_ERRBUF_SIZE]; // error string buffer
	unsigned char   m_aucLocalMAC[6];

#if PCAP_Q_SEND
	pcap_send_queue*  m_pcapSendQ; 
	unsigned int      m_ulCount;
	list<unsigned char*> m_listPktMem;
	unsigned int      m_ulTotalSize;
	list<MyPkt> m_listPkt;
#endif
	unsigned int m_ulCntPktSendFail;
	unsigned int m_ulCntTotPktSend;
	unsigned int m_ulCnt2ndPktSendFail;


	

	
};
