#include "XMLParserCtrl.h"

CXMLParserCtrl::CXMLParserCtrl(const char* pszPath)
{
	if( pszPath != NULL )
	{
		//m_strXMLPath   = strPath;
		m_pObjTiXMLDoc =  new TiXmlDocument(pszPath);
	}
	else
	{
		m_pObjTiXMLDoc = NULL;
	}
}

CXMLParserCtrl::~CXMLParserCtrl(void)
{
	if( m_pObjTiXMLDoc != NULL )
	{
		delete m_pObjTiXMLDoc;
	}
}

BOOL CXMLParserCtrl::LoadXML( void )
{
	BOOL bLoadOK;

	if( m_pObjTiXMLDoc != NULL )
	{
		bLoadOK = m_pObjTiXMLDoc->LoadFile();
	}
	else
	{
		bLoadOK = FALSE;
	}

	return bLoadOK;
}

int CXMLParserCtrl::LookXMLAttribute(TiXmlElement* pElement)
{
	if( pElement == NULL )
	{
		return 0;
	}

	TiXmlAttribute* pAttrib=pElement->FirstAttribute();
	int i=0;
	//int ival;
	//double dval;
	//const char* pIndent=getIndent(indent);

	while (pAttrib)
	{
		if( !strcmp( pAttrib->Name(), "group") )
		{
			m_strGroup = pAttrib->Value();
		}
		else if( !strcmp( pAttrib->Name(), "source") )
		{
			m_strSource = pAttrib->Value();
		}
		else if( !strcmp( pAttrib->Name(), "port") )
		{
			m_strPort = pAttrib->Value();
		}
		else if( !strcmp( pAttrib->Name(), "name") )
		{
			m_strPlayer = pAttrib->Value();
		}
		else if( !strcmp( pAttrib->Name(), "command") )
		{
			m_strCommand = pAttrib->Value();
		}
		i++;
		pAttrib=pAttrib->Next();
	}
	return i;	
}

void CXMLParserCtrl::GetAMTInfo(TiXmlNode* pParent)
{
	if( pParent == NULL )
		return;

	TiXmlNode* pChild;
	TiXmlText* pText;

	int nType = pParent->Type();

	switch( nType )
	{
		case TiXmlNode::DOCUMENT:
			// nothing to do
			break;

		case TiXmlNode::ELEMENT:
			LookXMLAttribute(pParent->ToElement());
			break;

		case TiXmlNode::COMMENT:
			// nothing to do
			break;

		case TiXmlNode::UNKNOWN:
			// nothing to do
			break;

		case TiXmlNode::TEXT:
			// nothing to do
			pText = pParent->ToText();
			break;

		case TiXmlNode::DECLARATION:
			// nothing to do
			break;
		default:
			break;
	}

	for ( pChild = pParent->FirstChild(); pChild != 0; pChild = pChild->NextSibling()) 
	{
		GetAMTInfo( pChild) ;
	}

}


void CXMLParserCtrl::ParseAMTInfo( void )
{
	if( m_pObjTiXMLDoc != NULL )
	{
		GetAMTInfo(	m_pObjTiXMLDoc );	
	}

}

unsigned long CXMLParserCtrl::GetGroupAddress( void )
{
	unsigned long ulGrpAddress = 0;

	ulGrpAddress = inet_addr( m_strGroup.c_str() );

	return ulGrpAddress;
}

unsigned long CXMLParserCtrl::GetSrcAddress( void )
{
	unsigned long ulSrcAddress = 0;

	ulSrcAddress = inet_addr( m_strSource.c_str() );

	return ulSrcAddress;
}

unsigned short CXMLParserCtrl::GetPortNumber( void )
{
	unsigned short usPort = 0;

	usPort = (unsigned short)atoi( m_strPort.c_str() );

	return usPort;
}

string& CXMLParserCtrl::GetPlayerName( void )
{
	return m_strPlayer;
}

string& CXMLParserCtrl::GetCommandLine( void )
{
	return m_strCommand;
}
